Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/nemogcm.F90
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/nemogcm.F90	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/nemogcm.F90	(revision 12184)
@@ -46,5 +46,5 @@
    USE closea         ! treatment of closed seas (for ln_closea)
    USE usrdef_nam     ! user defined configuration
-   USE tideini        ! tidal components initialization   (tide_ini routine)
+   USE tide_mod, ONLY : tide_init ! tidal components initialization   (tide_init routine)
    USE bdy_oce,  ONLY : ln_bdy
    USE bdyini         ! open boundary cond. setting       (bdy_init routine)
@@ -59,5 +59,5 @@
    USE diaobs         ! Observation diagnostics       (dia_obs_init routine)
    USE diacfl         ! CFL diagnostics               (dia_cfl_init routine)
-   USE diaharm        ! tidal harmonics diagnostics  (dia_harm_init routine)
+   USE diamlr         ! IOM context management for multiple-linear-regression analysis
    USE step           ! NEMO time-stepping                 (stp     routine)
    USE isfstp         ! ice shelf                     (isf_stp_init routine)
@@ -75,4 +75,5 @@
    USE diatmb         ! Top,middle,bottom output
    USE dia25h         ! 25h mean output
+   USE diadetide      ! Weights computation for daily detiding of model diagnostics
    USE sbc_oce , ONLY : lk_oasis
    USE wet_dry        ! Wetting and drying setting   (wad_init routine)
@@ -491,6 +492,7 @@
                            CALL dia_tmb_init    ! TMB outputs
                            CALL dia_25h_init    ! 25h mean  outputs
-                           CALL dia_harm_init   ! tidal harmonics outputs
+                           CALL dia_detide_init ! Weights computation for daily detiding of model diagnostics
      IF( ln_diaobs    )    CALL dia_obs( nit000-1 )   ! Observation operator for restart
+                           CALL dia_mlr_init    ! Initialisation of IOM context management for multiple-linear-regression analysis
 
       !                                      ! Assimilation increments
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/step.F90
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/step.F90	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/step.F90	(revision 12184)
@@ -100,5 +100,7 @@
                              
       IF( kstp == nit000 ) THEN                       ! initialize IOM context (must be done after nemo_init for AGRIF+XIOS+OASIS)
-                             CALL iom_init(      cxios_context          )  ! for model grid (including passible AGRIF zoom)
+                             CALL iom_init( cxios_context, ld_closedef=.FALSE. )   ! for model grid (including passible AGRIF zoom)
+         IF( lk_diamlr   )   CALL dia_mlr_iom_init    ! with additional setup for multiple-linear-regression analysis
+                             CALL iom_init_closedef
          IF( ln_crs      )   CALL iom_init( TRIM(cxios_context)//"_crs" )  ! for coarse grid
       ENDIF
@@ -110,5 +112,5 @@
       ! Update external forcing (tides, open boundaries, and surface boundary condition (including sea-ice)
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-      IF( ln_tide    )   CALL sbc_tide( kstp )                   ! update tide potential
+      IF( ln_tide    )   CALL tide_update( kstp )                ! update tide potential
       IF( ln_apr_dyn )   CALL sbc_apr ( kstp )                   ! atmospheric pressure (NB: call before bdy_dta which needs ssh_ib) 
       IF( ln_bdy     )   CALL bdy_dta ( kstp, kt_offset = +1 )   ! update dynamic & tracer data at open boundaries
@@ -209,7 +211,8 @@
                          CALL dia_ar5 ( kstp )        ! ar5 diag
                          CALL dia_ptr ( kstp )        ! Poleward adv/ldf TRansports diagnostics
-      IF( ln_diaharm )   CALL dia_harm( kstp )        ! Tidal harmonic analysis
                          CALL dia_wri ( kstp )        ! ocean model: outputs
       !
+      IF( lk_diadetide ) CALL dia_detide( kstp )      ! Weights computation for daily detiding of model diagnostics
+      IF( lk_diamlr  )   CALL dia_mlr                 ! Update time used in multiple-linear-regression analysis
       IF( ln_crs     )   CALL crs_fld       ( kstp )  ! ocean model: online field coarsening & output
       
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/step_oce.F90
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/step_oce.F90	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/src/OCE/step_oce.F90	(revision 12184)
@@ -19,5 +19,5 @@
    USE sbccpl          ! surface boundary condition: coupled formulation (call send at end of step)
    USE sbcapr          ! surface boundary condition: atmospheric pressure
-   USE sbctide         ! Tide initialisation
+   USE tide_mod, ONLY : ln_tide, tide_update
    USE sbcwave         ! Wave intialisation
 
@@ -83,7 +83,8 @@
    USE diahth          ! thermocline depth                (dia_hth routine)
    USE diahsb          ! heat, salt and volume budgets    (dia_hsb routine)
-   USE diaharm
    USE diacfl
    USE diaobs          ! Observation operator
+   USE diadetide       ! Weights computation for daily detiding of model diagnostics
+   USE diamlr          ! IOM context management for multiple-linear-regression analysis
    USE flo_oce         ! floats variables
    USE floats          ! floats computation               (flo_stp routine)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/CANAL/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/CANAL/EXPREF/namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/CANAL/EXPREF/namelist_cfg	(revision 12184)
@@ -276,5 +276,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg	(revision 12184)
@@ -202,5 +202,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_120pts
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_120pts	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_120pts	(revision 12184)
@@ -202,5 +202,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_240pts
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_240pts	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_240pts	(revision 12184)
@@ -202,5 +202,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_60pts
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_60pts	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV1D/EXPREF/namelist_cfg_60pts	(revision 12184)
@@ -202,5 +202,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV2D/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV2D/EXPREF/namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_ADV2D/EXPREF/namelist_cfg	(revision 12184)
@@ -202,5 +202,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_AGRIF/EXPREF/1_namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_AGRIF/EXPREF/1_namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_AGRIF/EXPREF/1_namelist_cfg	(revision 12184)
@@ -202,5 +202,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_AGRIF/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_AGRIF/EXPREF/namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ICE_AGRIF/EXPREF/namelist_cfg	(revision 12184)
@@ -202,5 +202,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ISOMIP/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ISOMIP/EXPREF/namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/ISOMIP/EXPREF/namelist_cfg	(revision 12184)
@@ -428,5 +428,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/LOCK_EXCHANGE/EXPREF/namelist_FCT2_flux_ubs_cfg	(revision 12184)
@@ -276,5 +276,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/OVERFLOW/EXPREF/namelist_zps_FCT4_flux_ubs_cfg	(revision 12184)
@@ -294,5 +294,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/VORTEX/EXPREF/1_namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/VORTEX/EXPREF/1_namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/VORTEX/EXPREF/1_namelist_cfg	(revision 12184)
@@ -273,5 +273,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/VORTEX/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/VORTEX/EXPREF/namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/VORTEX/EXPREF/namelist_cfg	(revision 12184)
@@ -264,5 +264,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default; OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
Index: /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/WAD/EXPREF/namelist_cfg
===================================================================
--- /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/WAD/EXPREF/namelist_cfg	(revision 12183)
+++ /NEMO/branches/2019/dev_r12072_MERGE_OPTION2_2019/tests/WAD/EXPREF/namelist_cfg	(revision 12184)
@@ -422,5 +422,4 @@
 !!   namdiu       Cool skin and warm layer models                       (default: OFF)
 !!   namflo       float parameters                                      (default: OFF)
-!!   nam_diaharm  Harmonic analysis of tidal constituents               (default: OFF)
 !!   nam_diadct   transports through some sections                      (default: OFF)
 !!   nam_diatmb   Top Middle Bottom Output                              (default: OFF)
